org.apache.hc.core5.http.nio.support

## Class AbstractServerExchangeHandler<T>

- java.lang.Object
- - org.apache.hc.core5.http.nio.support.AbstractServerExchangeHandler<T>

- All Implemented Interfaces:
    AsyncDataConsumer, AsyncDataExchangeHandler, AsyncDataProducer, AsyncServerExchangeHandler, ResourceHolder
  Direct Known Subclasses:
    BasicServerExchangeHandler

      public abstract class AbstractServerExchangeHandler<T>
      extends Object
      implements AsyncServerExchangeHandler

  Abstract server side message exchange handler.
  Since:
    5.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractServerExchangeHandler()`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `available()` Returns the number of bytes immediately available for output.
    `void` | `consume(ByteBuffer src)` Triggered to pass incoming data to the data consumer.
    `void` | `failed(Exception cause)` Triggered to signal a failure in data processing.
    `protected abstract void` | `handle(T requestMessage, AsyncServerRequestHandler.ResponseTrigger responseTrigger, HttpContext context)` Triggered to handles the request object produced by the `AsyncRequestConsumer` returned from the `supplyConsumer(HttpRequest, EntityDetails, HttpContext)` method.
    `void` | `handleRequest(HttpRequest request, EntityDetails entityDetails, ResponseChannel responseChannel, HttpContext context)` Processes the actual HTTP request.
    `void` | `produce(DataStreamChannel channel)` Triggered to signal the ability of the underlying data channel to accept more data.
    `void` | `releaseResources()`
    `void` | `streamEnd(List<? extends Header> trailers)` Triggered to signal termination of the data stream.
    `protected abstract AsyncRequestConsumer<T>` | `supplyConsumer(HttpRequest request, EntityDetails entityDetails, HttpContext context)` Triggered to supply a request consumer to process the incoming request.
    `void` | `updateCapacity(CapacityChannel capacityChannel)` Triggered to signal ability of the underlying data stream to receive data capacity update.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AbstractServerExchangeHandler

          public AbstractServerExchangeHandler()

  - ### Method Detail

    - #### supplyConsumer

          protected abstract AsyncRequestConsumer<T> supplyConsumer(HttpRequest request,
                                                                    EntityDetails entityDetails,
                                                                    HttpContext context)
                                                             throws HttpException

      Triggered to supply a request consumer to process the incoming request.
      Parameters:
        `request` - the request message.
        `entityDetails` - the request entity details.
        `context` - the actual execution context.
      Returns:
        the request consumer.
      Throws:
        `HttpException`

    - #### handle

          protected abstract void handle(T requestMessage,
                                         AsyncServerRequestHandler.ResponseTrigger responseTrigger,
                                         HttpContext context)
                                  throws HttpException,
                                         IOException

      Triggered to handles the request object produced by the `AsyncRequestConsumer` returned from the `supplyConsumer(HttpRequest, EntityDetails, HttpContext)` method. The handler can choose to send response messages immediately inside the call or asynchronously at some later point.
      Parameters:
        `requestMessage` - the request message.
        `responseTrigger` - the response trigger.
        `context` - the actual execution context.
      Throws:
        `HttpException`
        `IOException`

    - #### handleRequest

          public final void handleRequest(HttpRequest request,
                                          EntityDetails entityDetails,
                                          ResponseChannel responseChannel,
                                          HttpContext context)
                                   throws HttpException,
                                          IOException

      Description copied from interface: `AsyncServerExchangeHandler`
      Processes the actual HTTP request. The handler can choose to send response messages immediately inside the call or asynchronously at some later point.
      Specified by:
        `handleRequest` in interface `AsyncServerExchangeHandler`
      Parameters:
        `request` - the actual request.
        `entityDetails` - the request entity details or `null` if the request does not enclose an entity.
        `responseChannel` - the response channel.
        `context` - the actual execution context.
      Throws:
        `HttpException`
        `IOException`

    - #### updateCapacity

          public final void updateCapacity(CapacityChannel capacityChannel)
                                    throws IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to signal ability of the underlying data stream to receive data capacity update. The data consumer can choose to write data immediately inside the call or asynchronously at some later point.
      Specified by:
        `updateCapacity` in interface `AsyncDataConsumer`
      Parameters:
        `capacityChannel` - the channel for capacity updates.
      Throws:
        `IOException`

    - #### consume

          public final void consume(ByteBuffer src)
                             throws IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to pass incoming data to the data consumer. The consumer must consume the entire content of the data buffer. The consumer must stop incrementing its capacity on the capacity channel if it is unable to accept more data. Once the data consumer has handled accumulated data or allocated more intermediate storage it can update its capacity information on the capacity channel.
      Specified by:
        `consume` in interface `AsyncDataConsumer`
      Parameters:
        `src` - data source.
      Throws:
        `IOException`

    - #### streamEnd

          public final void streamEnd(List<? extends Header> trailers)
                               throws HttpException,
                                      IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to signal termination of the data stream.
      Specified by:
        `streamEnd` in interface `AsyncDataConsumer`
      Parameters:
        `trailers` - data stream trailers.
      Throws:
        `HttpException`
        `IOException`

    - #### available

          public final int available()

      Description copied from interface: `AsyncDataProducer`
      Returns the number of bytes immediately available for output. This method can be used as a hint to control output events of the underlying I/O session.
      Specified by:
        `available` in interface `AsyncDataProducer`
      Returns:
        the number of bytes immediately available for output

    - #### produce

          public final void produce(DataStreamChannel channel)
                             throws IOException

      Description copied from interface: `AsyncDataProducer`
      Triggered to signal the ability of the underlying data channel to accept more data. The data producer can choose to write data immediately inside the call or asynchronously at some later point.
      Specified by:
        `produce` in interface `AsyncDataProducer`
      Parameters:
        `channel` - the data channel capable to accepting more data.
      Throws:
        `IOException`

    - #### failed

          public final void failed(Exception cause)

      Description copied from interface: `AsyncDataExchangeHandler`
      Triggered to signal a failure in data processing.
      Specified by:
        `failed` in interface `AsyncDataExchangeHandler`
      Parameters:
        `cause` - the cause of the failure.

    - #### releaseResources

          public final void releaseResources()

      Specified by:
        `releaseResources` in interface `ResourceHolder`

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.